diff --git a/include/lib.sh b/include/lib.sh
index e439ef8bee3..b43d83f3f87 100644
--- a/include/lib.sh
+++ b/include/lib.sh
@@ -1,7 +1,7 @@
 # SPDX-License-Identifier: GPL-3.0-only
 # Copyright (c) 2022 Caleb La Grange <thonkpeasant@protonmail.com>
 # Copyright (c) 2022 Ferass El Hafidi <vitali64pmemail@protonmail.com>
-# Copyright (c) 2020-2024 Leah Rowe <leah@libreboot.org>
+# Copyright (c) 2020-2025 Leah Rowe <leah@libreboot.org>
 
 export LC_COLLATE=C
 export LC_ALL=C
@@ -10,6 +10,7 @@ _ua="Mozilla/5.0 (Windows NT 10.0; rv:91.0) Gecko/20100101 Firefox/91.0"
 
 ifdtool="elf/ifdtool/default/ifdtool"
 cbfstool="elf/cbfstool/default/cbfstool"
+rmodtool="elf/cbfstool/default/rmodtool"
 tmpgit="$PWD/tmp/gitclone"
 grubdata="config/data/grub"
 err="err_"
@@ -22,23 +23,23 @@ err_()
 setvars()
 {
 	_setvars="" && [ $# -lt 2 ] && $err "setvars: too few arguments"
-	val="$1" && shift 1 && for var in $@; do
+	val="$1" && shift 1 && for var in "$@"; do
 		_setvars="$var=\"$val\"; $_setvars"
 	done; printf "%s\n" "${_setvars% }"
 }
 chkvars()
 {
-	for var in $@; do
-		eval "[ -n "\${$var+x}" ] || \$err \"$var unset\""
-		eval "[ -n "\$$var" ] || \$err \"$var unset\""
+	for var in "$@"; do
+		eval "[ -n \"\${$var+x}\" ] || \$err \"$var unset\""
+		eval "[ -n \"\$$var\" ] || \$err \"$var unset\""
 	done; return 0
 }
 
-eval `setvars "" _nogit board xbmk_parent versiondate projectsite projectname \
-    aur_notice configdir datadir version relname`
+eval "`setvars "" _nogit board reinstall versiondate projectsite projectname \
+    aur_notice configdir datadir version relname xbmk_parent`"
 
 for fv in projectname projectsite version versiondate; do
-	eval "[ ! -f "$fv" ] || read -r $fv < \"$fv\" || :"
+	eval "[ ! -f \"$fv\" ] || read -r $fv < \"$fv\" || :"
 done; chkvars projectname projectsite
 
 setcfg()
@@ -62,37 +63,72 @@ e()
 install_packages()
 {
 	[ $# -lt 2 ] && $err "fewer than two arguments"
-	eval `setcfg "config/dependencies/$2"`
+	[ $# -gt 2 ] && reinstall="$3"
 
+	eval "`setcfg "config/dependencies/$2"`"
+
+	chkvars pkg_add pkglist
 	$pkg_add $pkglist || $err "Cannot install packages"
 
 	[ -n "$aur_notice" ] && \
-	printf "You need AUR packages: %s\n" "$aur_notice" 1>&2; return 0
+	    printf "You need AUR packages: %s\n" "$aur_notice" 1>&2; :
 }
-[ $# -gt 0 ] && [ "$1" = "dependencies" ] && install_packages $@ && exit 0
+if [ $# -gt 0 ] && [ "$1" = "dependencies" ]; then
+	install_packages "$@" || exit 1
+	exit 0
+fi
+
+pyver="2"
+python="python3"
+command -v python3 1>/dev/null || python="python"
+command -v $python 1>/dev/null || pyver=""
+[ -z "$pyver" ] || \
+	python -c 'import sys; print(sys.version_info[:])' 1>/dev/null \
+	    2>/dev/null || $err "Cannot determine which Python version."
+[ -n "$pyver" ] && \
+	pyver="`python -c 'import sys; print(sys.version_info[:])' | \
+	    awk '{print $1}'`" && \
+	pyver="${pyver#(}" && pyver="${pyver%,}"
+if [ "${pyver%%.*}" != "3" ]; then
+	printf "Wrong python version, or python missing. Must be v 3.x.\n" 1>&2
+	exit 1
+fi
 
 id -u 1>/dev/null 2>/dev/null || $err "suid check failed (id -u)"
 [ "$(id -u)" != "0" ] || $err "this command as root is not permitted"
 
+# XBMK_CACHE is a directory, for caching downloads and git repositories
+[ -z "${XBMK_CACHE+x}" ] && export XBMK_CACHE="$PWD/cache"
+[ -z "$XBMK_CACHE" ] && export XBMK_CACHE="$PWD/cache"
+[ -L "$XBMK_CACHE" ] && [ "$XBMK_CACHE" = "$PWD/cache" ] && \
+    $err "cachedir is default, $PWD/cache, but it exists and is a symlink"
+[ -L "$XBMK_CACHE" ] && export XBMK_CACHE="$PWD/cache"
+[ -f "$XBMK_CACHE" ] && $err "cachedir '$XBMK_CACHE' exists but it's a file"
+
+# unify all temporary files/directories in a single TMPDIR
 [ -z "${TMPDIR+x}" ] || [ "${TMPDIR%_*}" = "/tmp/xbmk" ] || unset TMPDIR
 [ -n "${TMPDIR+x}" ] && export TMPDIR="$TMPDIR"
-
 if [ -z "${TMPDIR+x}" ]; then
 	[ -f "lock" ] && $err "$PWD/lock exists. Is a build running?"
 	export TMPDIR="/tmp"
 	export TMPDIR="$(mktemp -d -t xbmk_XXXXXXXX)"
 	touch lock || $err "cannot create 'lock' file"
+	rm -Rf "$XBMK_CACHE/xbmkpath" "$XBMK_CACHE/gnupath" || \
+	    $err "cannot remove xbmkpath"
+	mkdir -p "$XBMK_CACHE/gnupath" "$XBMK_CACHE/xbmkpath" || \
+	    $err "cannot create gnupath"
+	export PATH="$XBMK_CACHE/xbmkpath:$XBMK_CACHE/gnupath:$PATH" || \
+	    $err "Can't create gnupath/xbmkpath"
+	(
+	# set up python v3.x in PATH, in case it's not set up correctly.
+	# see code above that detected the correct python3 command.
+	cd "$XBMK_CACHE/xbmkpath" || $err "can't cd $XBMK_CACHE/xbmkpath"
+	ln -s "`command -v "$python"`" python || \
+	    $err "Can't set up python symlink in $XBMK_CACHE/xbmkpath"
+	) || $err "Can't set up python symlink in $XBMK_CACHE/xbmkpath"
 	xbmk_parent="y"
 fi
 
-# XBMK_CACHE is a directory, for caching downloads and git repositories
-[ -z "${XBMK_CACHE+x}" ] && export XBMK_CACHE="$PWD/cache"
-[ -z "$XBMK_CACHE" ] && export XBMK_CACHE="$PWD/cache"
-[ -L "$XBMK_CACHE" ] && [ "$XBMK_CACHE" = "$PWD/cache" ] && \
-    $err "cachedir is default, $PWD/cache, but it exists and is a symlink"
-[ -L "$XBMK_CACHE" ] && export XBMK_CACHE="$PWD/cache"
-[ -f "$XBMK_CACHE" ] && $err "cachedir '$XBMK_CACHE' exists but it's a file"
-
 # if "y": a coreboot target won't be built if target.cfg says release="n"
 # (this is used to exclude certain build targets from releases)
 [ -z "${XBMK_RELEASE+x}" ] && export XBMK_RELEASE="n"
@@ -103,7 +139,7 @@ expr "X$XBMK_THREADS" : "X-\{0,1\}[0123456789][0123456789]*$" \
     1>/dev/null 2>/dev/null || export XBMK_THREADS=1 # user gave a non-integer
 
 x_() {
-	[ $# -lt 1 ] || $@ || \
+	[ $# -lt 1 ] || "$@" || \
 	    $err "Unhandled non-zero exit: $(echo "$@")"; return 0
 }
 
@@ -149,11 +185,10 @@ mkrom_tarball()
 
 mktarball()
 {
-	[ "${2%/*}" = "$2" ] || \
+	if [ "${2%/*}" != "$2" ]; then
 		mkdir -p "${2%/*}" || $err "mk, !mkdir -p \"${2%/*}\""
-	printf "\nCreating archive: %s\n\n" "$2"
+	fi
 	tar -c "$1" | xz -T$XBMK_THREADS -9e > "$2" || $err "mktarball 2, $1"
-	mksha512sum "$2" "${2##*/}.sha512"
 }
 
 mksha512sum()
@@ -182,8 +217,11 @@ singletree()
 	done; return 0
 }
 
+# can grab from the internet, or copy locally.
+# if copying locally, it can only copy a file.
 download()
 {
+	_dlop="curl" && [ $# -gt 4 ] && _dlop="$5"
 	cached="$XBMK_CACHE/file/$4"
 	dl_fail="n" # 1 url, 2 url backup, 3 destination, 4 checksum
 	vendor_checksum "$4" "$cached" 2>/dev/null && dl_fail="y"
@@ -194,8 +232,21 @@ download()
 		[ "$dl_fail" = "n" ] && break
 		[ -z "$url" ] && continue
 		rm -f "$cached" || $err "!rm -f '$cached'"
-		curl --location --retry 3 -A "$_ua" "$url" -o "$cached" || \
-		    wget --tries 3 -U "$_ua" "$url" -O "$cached" || continue
+		if [ "$_dlop" = "curl" ]; then
+			curl --location --retry 3 -A "$_ua" "$url" \
+			    -o "$cached" || wget --tries 3 -U "$_ua" "$url" \
+			    -O "$cached" || continue
+		elif [ "$_dlop" = "copy" ]; then
+			[ -L "$url" ] && \
+				printf "dl %s %s %s %s: '%s' is a symlink\n" \
+				    "$1" "$2" "$3" "$4" "$url" 1>&2 && continue
+			[ ! -f "$url" ] && \
+				printf "dl %s %s %s %s: '%s' not a file\n" \
+				    "$1" "$2" "$3" "$4" "$url" 1>&2 && continue
+			cp "$url" "$cached" || continue
+		else
+			$err "$1 $2 $3 $4: Unsupported dlop type: '$_dlop'"
+		fi
 		vendor_checksum "$4" "$cached" || dl_fail="n"
 	done; [ "$dl_fail" = "y" ] && $err "$1 $2 $3 $4: not downloaded"
 	[ "$cached" = "$3" ] || cp "$cached" "$3" || $err "!d cp $cached $3"; :
@@ -232,7 +283,7 @@ cbfs()
 mk()
 {
 	mk_flag="$1" || $err "No argument given"
-	shift 1 && for mk_arg in $@; do
+	shift 1 && for mk_arg in "$@"; do
 		./mk $mk_flag $mk_arg || $err "./mk $mk_flag $mk_arg"; :
 	done; :
 }
diff --git a/include/mrc.sh b/include/mrc.sh
index 2e00d9f9289..f5db2ff087a 100644
--- a/include/mrc.sh
+++ b/include/mrc.sh
@@ -4,7 +4,7 @@
 # Modifications in this version are Copyright 2021, 2023 and 2024 Leah Rowe.
 # Original copyright detailed in repo: https://review.coreboot.org/coreboot/
 
-eval `setvars "" MRC_url MRC_url_bkup MRC_hash MRC_board SHELLBALL`
+eval "`setvars "" MRC_url MRC_url_bkup MRC_hash MRC_board SHELLBALL`"
 
 extract_mrc()
 {
diff --git a/include/rom.sh b/include/rom.sh
index 8d9cdf40e32..3e8c9c9b959 100644
--- a/include/rom.sh
+++ b/include/rom.sh
@@ -1,18 +1,30 @@
 # SPDX-License-Identifier: GPL-3.0-or-later
-# Copyright (c) 2014-2016,2020-2021,2023-2024 Leah Rowe <leah@libreboot.org>
+# Copyright (c) 2014-2016,2020-2021,2023-2025 Leah Rowe <leah@libreboot.org>
 # Copyright (c) 2021-2022 Ferass El Hafidi <vitali64pmemail@protonmail.com>
 # Copyright (c) 2022 Caleb La Grange <thonkpeasant@protonmail.com>
 # Copyright (c) 2022-2023 Alper Nebi Yasak <alpernebiyasak@gmail.com>
-# Copyright (c) 2023 Riku Viitanen <riku.viitanen@protonmail.com>
+# Copyright (c) 2023-2024 Riku Viitanen <riku.viitanen@protonmail.com>
 
 mkserprog()
 {
+	[ $# -lt 1 ] && $err "mkserprog: no arguments provided"
 	[ "$_f" = "-d" ] && return 0 # dry run
+
+	[ "$1" = "pico" ] && mkpicotool
+
 	basename -as .h "$serdir/"*.h > "$TMPDIR/ser" || $err "!mk $1 $TMPDIR"
 
 	while read -r sertarget; do
-		[ "$1" = "rp2040" ] && x_ cmake -DPICO_BOARD="$sertarget" \
+		[ "$1" = "pico" ] &&
+		    x_ rm -rf "$sersrc/build" \
+		    && (pt=$(x_ grep "pico_cmake_set" \
+		          "$picosdk/src/boards/include/boards/$sertarget.h" \
+		        | grep "PICO_PLATFORM" | cut -d= -f2 | tr -d [:blank:])
+		        mkdir -p "$sersrc/build_$pt"
+			ln -srf "$sersrc/build_$pt/" "$sersrc/build") \
+		    && x_ cmake -DPICO_BOARD="$sertarget" \
 		    -DPICO_SDK_PATH="$picosdk" -B "$sersrc/build" "$sersrc" \
+		    -Dpicotool_DIR="$picotool/picotool" \
 		    && x_ cmake --build "$sersrc/build"
 		[ "$1" = "stm32" ] && x_ make -C "$sersrc" \
 		    libopencm3-just-make BOARD=$sertarget && x_ make -C \
@@ -23,6 +35,18 @@ mkserprog()
 	[ "$XBMK_RELEASE" = "y" ] && mkrom_tarball "bin/serprog_$1"; return 0
 }
 
+mkpicotool()
+{
+	rm -Rf "$picotool" || $err "Can't remove picotool builddir"
+	(
+	x_ cd src/picotool
+	cmake -DCMAKE_INSTALL_PREFIX=xbmkbin -DPICOTOOL_FLAT_INSTALL=1 \
+	    -DPICO_SDK_PATH=../pico-sdk || \
+	    $err "Can't prep picotool"
+	make install || $err "Can't build picotool"; :
+	) || $err "Can't build picotool"; :
+}
+
 copyps1bios()
 {
 	x_ rm -Rf bin/playstation
@@ -36,8 +60,8 @@ copyps1bios()
 
 mkpayload_grub()
 {
-	eval `setvars "" grub_modules grub_install_modules`
-	$dry eval `setcfg "$grubdata/module/$tree"`
+	eval "`setvars "" grub_modules grub_install_modules`"
+	$dry eval "`setcfg "$grubdata/module/$tree"`"
 	$dry x_ rm -f "$srcdir/grub.elf"; $dry \
 	"$srcdir/grub-mkstandalone" --grub-mkimage="$srcdir/grub-mkimage" \
 	    -O i386-coreboot -o "$srcdir/grub.elf" -d "${srcdir}/grub-core/" \
@@ -55,7 +79,7 @@ mkvendorfiles()
 	printf "%s\n" "${version%%-*}" > "$srcdir/.coreboot-version" || \
 	    $err "!mk $srcdir .coreboot-version"
 	[ -z "$mode" ] && [ "$target" != "$tree" ] && \
-	    x_ ./vendor download $target; return 0
+	    x_ ./mk download "$target"; return 0
 }
 
 cook_coreboot_config()
@@ -77,10 +101,14 @@ check_coreboot_utils()
 
 		utilmode="" && [ -n "$mode" ] && utilmode="clean"
 		x_ make -C "$utilsrcdir" $utilmode -j$XBMK_THREADS $makeargs
-		[ -z "$mode" ] && [ ! -f "$utilelfdir/$util" ] && \
-			x_ mkdir -p "$utilelfdir" && \
-			x_ cp "$utilsrcdir/$util" "elf/$util/$1"
-		[ -z "$mode" ] || x_ rm -Rf "$utilelfdir"; continue
+		if [ -z "$mode" ] && [ ! -f "$utilelfdir/$util" ]; then
+			x_ mkdir -p "$utilelfdir"
+			x_ cp "$utilsrcdir/$util" "$utilelfdir"
+			[ "$util" = "cbfstool" ] || continue
+			x_ cp "$utilsrcdir/rmodtool" "$utilelfdir"
+		elif [ -n "$mode" ]; then
+			x_ rm -Rf "$utilelfdir"
+		fi; continue
 	done; return 0
 }
 
@@ -102,7 +130,8 @@ mkcorebootbin()
 
 	if [ "$payload_uboot_i386" = "y" ] || \
 	    [ "$payload_uboot_amd64" = "y" ]; then
-		printf "'$target' has x86 U-Boot; assuming SeaBIOS=y\n" 1>&2
+		printf "'%s' has x86 U-Boot; assuming SeaBIOS=y\n" \
+		    "$target" 1>&2
 		payload_seabios="y"
 	fi
 
@@ -120,6 +149,10 @@ mkcorebootbin()
 	[ "$payload_memtest" = "y" ] || payload_memtest="n"
 	[ "$(uname -m)" = "x86_64" ] || payload_memtest="n"
 
+	[ "$payload_grubsea" = "y" ] && [ "$initmode" = "normal" ] && \
+	    payload_grubsea="n"
+	[ "$payload_grub" = "y" ] || payload_grubsea="n"
+
 	if $dry grep "CONFIG_PAYLOAD_NONE=y" "$defconfig"; then
 		[ "$payload_seabios" = "y" ] && pname="seabios" && \
 		    $dry add_seabios
@@ -138,7 +171,9 @@ add_seabios()
 
 	_seabioself="elf/seabios/default/$initmode/bios.bin.elf"
 
-	cbfs "$tmprom" "$_seabioself" "fallback/payload"
+	_seaname="fallback/payload" && [ "$payload_grubsea" = "y" ] && \
+	    _seaname="seabios.elf"
+	cbfs "$tmprom" "$_seabioself" "$_seaname"
 	x_ "$cbfstool" "$tmprom" add-int -i 3000 -n etc/ps2-keyboard-spinup
 
 	_z="2"; [ "$initmode" = "vgarom" ] && _z="0"
@@ -152,15 +187,18 @@ add_seabios()
 
 	[ "$payload_grub" = "y" ] && add_grub
 
-	cprom
+	[ "$payload_grubsea" != "y" ] && cprom
 	[ "$payload_uboot_amd64" = "y" ] && [ "$displaymode" != "txtmode" ] && \
-	    [ "$initmode" != "normal" ] && pname="seauboot" && cprom "seauboot"
+	    [ "$initmode" != "normal" ] && [ "$payload_grubsea" != "y" ] && \
+	    pname="seauboot" && cprom "seauboot"
 	[ "$payload_grub" = "y" ] && pname="seagrub" && mkseagrub; :
 }
 
 add_grub()
 {
-	cbfs "$tmprom" "$grubelf" "img/grub2"
+	_grubname="img/grub2" && [ "$payload_grubsea" = "y" ] && \
+	    _grubname="fallback/payload"
+	cbfs "$tmprom" "$grubelf" "$_grubname"
 	printf "set grub_scan_disk=\"%s\"\n" "$grub_scan_disk" \
 	    > "$TMPDIR/tmpcfg" || $err "$target: !insert scandisk"
 	cbfs "$tmprom" "$TMPDIR/tmpcfg" scan.cfg raw
@@ -171,7 +209,11 @@ add_grub()
 
 mkseagrub()
 {
-	cbfs "$tmprom" "$grubdata/bootorder" bootorder raw
+	if [ "$payload_grubsea" = "y" ]; then
+		pname="grub"
+	else
+		cbfs "$tmprom" "$grubdata/bootorder" bootorder raw
+	fi
 	for keymap in config/data/grub/keymap/*.gkb; do
 		[ -f "$keymap" ] && cprom "${keymap##*/}"; :
 	done; :
@@ -180,10 +222,12 @@ mkseagrub()
 add_uboot()
 {
 	if [ "$displaymode" = "txtmode" ]; then
-		printf "cb/$target: Cannot use U-Boot in text mode\n" 1>&2
+		printf "cb/%s: Cannot use U-Boot in text mode\n" \
+		    "$target" 1>&2
 		return 0
 	elif [ "$initmode" = "normal" ]; then
-		printf "cb/$target: Cannot use U-Boot in normal initmode\n" 1>&2
+		printf "cb/%s: Cannot use U-Boot in normal initmode\n" \
+		    "$target" 1>&2
 		return 0
 	fi
 
@@ -231,15 +275,16 @@ cprom()
 	x_ cp "$tmprom" "$newrom" && [ $# -gt 0 ] && [ "$1" != "seauboot" ] && \
 	    cbfs "$newrom" "config/data/grub/keymap/$1" keymap.gkb raw
 	[ $# -gt 0 ] && [ "$1" = "seauboot" ] && \
-	    cbfs "$newrom" "config/data/grub/bootorder_uboot" "bootorder" raw
-
-	[ "$XBMK_RELEASE" = "y" ] || return 0
-	$dry mksha512sum "$newrom" "vendorhashes"; $dry ./vendor inject \
-	    -r "$newrom" -b "$target" -n nuke || $err "!nuke $newrom"
+	    cbfs "$newrom" "config/data/grub/bootorder_uboot" bootorder raw; :
 }
 
 mkcoreboottar()
 {
-	[ "$target" = "$tree" ] && return 0; [ "$XBMK_RELEASE" = "y" ] && \
-	    [ "$release" != "n" ] && $dry mkrom_tarball "bin/$target"; :
+	[ "$target" = "$tree" ] && return 0
+	[ "$XBMK_RELEASE" = "y" ] || return 0
+	[ "$release" != "n" ] || return 0
+	$dry mkrom_tarball "bin/$target"
+	$dry ./mk inject "bin/${relname}_${target}.tar.xz" nuke || \
+	    $err "Can't delete vendorfiles in 'bin/${relname}_$target.tar.xz'"
+	return 0
 }
